﻿#region Using directives

using System;
using System.Collections.Generic;
using System.Text;

#endregion

namespace MetaHeuristics.Aco
{
    using MetaHeuristics.Collections;

    public class FirstImprovementTwoOptLocalSearch : BaseTwoOptLocalSearch
    {
        public override void Search()
        {
            foreach (Ant ant in this.Aco.Ants)
                this.Search(ant);
        }

        protected override void Search(Ant ant)
        {
            float delta = 0;
            for (int i = 1; i < this.Aco.Cities.Count-1; ++i)
            {
                for (int j = i + 1; j < this.Aco.Cities.Count-1; j++)
                {
                    delta = IfSwapElements(ant, i, j);
                    if (delta < 0) // improvement in objective function value
                    {
                        ant.Tours.Swap(i, j);
                        ant.Tours.Length += delta;
                        return;
                    }
                }
            }
        }
    }
}
